var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _DEFAULT_UPDATE_TYPES, _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import Tree from './Tree';
import { UPDATE_TYPE } from './contants';
import { getFlattenedTree } from './selectors/getFlattenedTree';
import { deleteNodeFromTree, replaceNodeFromTree } from './selectors/nodes';
import { Node } from './shapes/nodeShapes';

var DEFAULT_UPDATE_TYPES = (_DEFAULT_UPDATE_TYPES = {}, _DEFAULT_UPDATE_TYPES[UPDATE_TYPE.DELETE] = deleteNodeFromTree, _DEFAULT_UPDATE_TYPES[UPDATE_TYPE.UPDATE] = replaceNodeFromTree, _DEFAULT_UPDATE_TYPES);

var TreeContainer = (_temp = _class = function (_React$Component) {
  _inherits(TreeContainer, _React$Component);

  function TreeContainer(props) {
    _classCallCheck(this, TreeContainer);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.handleChange = function (_ref) {
      var node = _ref.node,
          type = _ref.type;

      var updatedNodes = _this.extensions.updateTypeHandlers[type](_this.nodes, node);

      _this.props.onChange(updatedNodes);
    };

    _this.extensions = props;
    return _this;
  }

  TreeContainer.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.extensions !== this.props.extensions) {
      this.extensions = nextProps;
    }
  };

  TreeContainer.prototype.render = function render() {
    return React.createElement(
      Tree,
      { nodes: getFlattenedTree(this.props.nodes), onChange: this.handleChange },
      this.props.children
    );
  };

  _createClass(TreeContainer, [{
    key: 'extensions',
    get: function get() {
      return this._extensions;
    },
    set: function set(props) {
      var _props$extensions = props.extensions;
      _props$extensions = _props$extensions === undefined ? {} : _props$extensions;
      var _props$extensions$upd = _props$extensions.updateTypeHandlers,
          updateTypeHandlers = _props$extensions$upd === undefined ? {} : _props$extensions$upd;


      this._extensions = {
        updateTypeHandlers: _extends({}, DEFAULT_UPDATE_TYPES, updateTypeHandlers)
      };
    }
  }, {
    key: 'nodes',
    get: function get() {
      return this.context.unfilteredNodes || this.props.nodes;
    }
  }]);

  return TreeContainer;
}(React.Component), _class.contextTypes = {
  unfilteredNodes: PropTypes.arrayOf(PropTypes.shape(Node))
}, _temp);
export { TreeContainer as default };
;

TreeContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  extensions: PropTypes.shape({
    updateTypeHandlers: PropTypes.object
  }),
  nodes: PropTypes.arrayOf(PropTypes.shape(Node)).isRequired,
  onChange: PropTypes.func,
  children: PropTypes.func.isRequired
} : {};